/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package xmldb;
import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;

/**
 *
 * @author bar
 */
public class XMLDBDemo {
    public static void main(String[] args) throws XMLDBException, ClassNotFoundException, InstantiationException, IllegalAccessException{
  
         Collection col = null;
         try {
             String driver = null;
             String prefix = null;

             if ( ( args.length == 1 ) && args[0].equals("dbxml") ) {
                 driver = "org.exist.xmldb.DatabaseImpl";
                 prefix = "xmldb:dbxml://localhost:8080/xmlrpc/";

             } else {
                 driver = "org.exist.xmldb.DatabaseImpl";
                 prefix = "xmldb:ref://localhost:8080/xmlrpc/";
             }

             Class c = Class.forName(driver);
             Database database = (Database) c.newInstance();

             if ( ! database.getConformanceLevel().equals("1") ) {
                 System.out.println("This program requires a Core Level 1 XML:DB " + "API driver");
                 System.exit(1);
             }
             DatabaseManager.registerDatabase(database);

             col = DatabaseManager.getCollection(prefix + "school");
             String xpath = "//student[@id = 12345678]";

             XPathQueryService service = (XPathQueryService) col.getService("XPathQueryService", "1.0");

             ResourceSet resultSet = service.query(xpath);
             ResourceIterator results = resultSet.getIterator();

             while (results.hasMoreResources()) {
                 Resource res = results.nextResource();
                 System.out.println((String) res.getContent());
             }
         } catch (XMLDBException e) {
             System.err.println("XML:DB Exception occurred " + e.errorCode + " " + e.getMessage());
         } finally {
             if (col != null) { col.close(); }
         }
     }
 }
 